from Lib.TestcaseBasicLibrary import *
from Pom.Home.Signin import *


@allure.epic('阿凡の博客 · 登录模块')
@allure.feature('测试登录站点')
class TestSignin:
    def setup_class(self):
        with allure.step('启动页面'):
            self.page = PageSignin(WebDriver()).open()

    def teardown_class(self):
        with allure.step('退出页面'):
            self.page.exit()

    @allure.severity('SMOKE')
    @allure.issue('https://demo16.zentao.net/bug-view-571.html', 'BUG #571 我是一个bug - UBTY - 禅道')
    @allure.testcase('https://demo16.zentao.net/testcase-view-943-1.html', 'CASE #943 把大象装进冰箱 - UBTY - 禅道')
    @allure.story('异常登录')
    @allure.title('测试异常登录')
    @allure.description('这是一段用例描述~')
    @pytest.mark.parametrize(('username', 'password'), [['super', 'super'], ['guest', 'guest'], ['users', 'users']])
    def test_errors_signin(self, username, password):
        with allure.step('刷新页面'):
            self.page.reload()
        with allure.step('输入账号'):
            self.page.input_user(username)
        with allure.step('输入密码'):
            self.page.input_pass(password)
        allure.attach(self.page.driver.screenshot(), '网页截图', allure.attachment_type.PNG)
        with allure.step('点击登录'):
            self.page.click_submit()
        allure.attach(self.page.driver.screenshot(), '网页截图', allure.attachment_type.PNG)

    @allure.severity(allure.severity_level.BLOCKER)
    @allure.story('正常登录')
    @allure.title('测试正常登录')
    @allure.description('这是一段用例描述~')
    @pytest.mark.parametrize(('username', 'password'), [['admin', 'admin']])
    def test_normal_signin(self, username, password):
        with allure.step('刷新页面'):
            self.page.reload()
        with allure.step('输入账号'):
            self.page.input_user(username)
        with allure.step('输入密码'):
            self.page.input_pass(password)
        allure.attach(self.page.driver.screenshot(), '网页截图', allure.attachment_type.PNG)
        with allure.step('点击登录'):
            self.page.click_submit()
        allure.attach(self.page.driver.screenshot(), '网页截图', allure.attachment_type.PNG)

    @allure.severity('P3')
    def test_failed(self):
        with allure.step('开始断言'):
            assert 1 < 0, 'Assert failed.'

    @allure.severity('p3')
    def test_errors(self):
        with allure.step('抛出异常'):
            raise Exception('This is a exception info.')
